Page MenuHomePhabricator

Not getting Adyen gateway for one-time US donations
Closed, ResolvedPublic

Description

We prepared the banners for tomorrow's US test of Ingenico vs Adyen. However in the Adyen banners, I noticed that despite specifying gateway=adyen it still sends to Special:IngenicoGateway. Weirdly this is only for one-time donations, recurring ones do go to Special:AdyenGateway

This doesn't seem to be a banner bug, since I can reproduce just by tweaking the URL parameters:

https://payments.wikimedia.org/index.php/Special:GatewayFormChooser?payment_method=cc&gateway=adyen&recurring=false&currency_code=USD&uselang=en&country=US&amount=20
goes to Special:IngenicoGateway (incorrect)

https://payments.wikimedia.org/index.php/Special:GatewayFormChooser?payment_method=cc&gateway=adyen&recurring=true&currency_code=USD&uselang=en&country=US&amount=20
goes to Special:AdyenGateway (as expected)

I did take a look at DonationInterfaceFormSettings.php myself, but couldn't see what might be wrong.

Event Timeline

Pcoombe created this task.Jun 2 2020, 6:54 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJun 2 2020, 6:54 PM

Change 601834 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[mediawiki/extensions/DonationInterface@master] Set adyen-usd form to 1 weight

https://gerrit.wikimedia.org/r/601834

Change 601834 merged by jenkins-bot:
[mediawiki/extensions/DonationInterface@master] Set adyen-usd form to 1 weight

https://gerrit.wikimedia.org/r/601834

Change 601879 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[mediawiki/extensions/DonationInterface@master] Shorten es email-explain

https://gerrit.wikimedia.org/r/601879

Change 601879 merged by jenkins-bot:
[mediawiki/extensions/DonationInterface@master] Shorten es email-explain

https://gerrit.wikimedia.org/r/601879

Ejegg added a subscriber: Ejegg.Jun 2 2020, 11:56 PM

Deployed!

Pcoombe closed this task as Resolved.Jun 3 2020, 11:21 AM
Pcoombe assigned this task to Ejegg.

Looks good now, thanks!

Pcoombe reopened this task as Open.Jun 3 2020, 12:16 PM

Actually @spatton pointed out that now if a gateway isn't specified, US one-time defaults to Adyen, which isn't the desired behaviour.

https://payments.wikimedia.org/index.php/Special:GatewayFormChooser?payment_method=cc&recurring=false&currency_code=USD&uselang=en&country=US&amount=20

Change 603540 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[mediawiki/extensions/DonationInterface@master] Explode out Adyen form settings by country

https://gerrit.wikimedia.org/r/603540

Ejegg added a comment.Jun 8 2020, 4:57 PM

Dang, the RapidHTML-era logic strikes again. The formsettings are still set up as though there was a hard-coded HTML form for each set of payment options (vma, vmaj, cvma). The chooser opts for the form with the most card options in that settings file, even though that may not correspond to the new reality of a single dynamic form that displays cards according to a different settings file. The attached patch exploding out form settings by country should make it work with that silly old logic, but the long-term fix is T131989 .

Change 603540 merged by jenkins-bot:
[mediawiki/extensions/DonationInterface@master] Explode out Adyen form settings by country

https://gerrit.wikimedia.org/r/603540

Ejegg added a comment.Jun 9 2020, 1:39 AM

Sorry for the error @Pcoombe and @spatton. I exploded the settings out to have a different section for each country, each with the accurate count of payment submethods and its own selection weight. That should be less confusing to manage till we get around to rewriting the form chooser logic.

Pcoombe closed this task as Resolved.Jun 9 2020, 2:54 PM

No problem @Ejegg, those settings are definitely confusing. Everything looks to be behaving as expected now, thanks!